--[[SHOOTING CLASS for Love 2D
Made by  :	Logan Tann for the "Kagerou Project Fangame (V2)".
			http://kagescan.esy.es/
			Under the MIT License
Inspiration:http://love2d.org/wiki/Tutorial:Fire_Toward_Mouse
Comment : 	it isn't very optimized but it works...
			You can modify it,for example,add limited shoots,in the time too,
			or delete old shoots (after displayed in the screen for more optimization)
Version :	1.0
]]

shoot = {} --make a new "class"

shoot.init = function (defaultX,defaultY,speed) local self = {} --begin class
	-- #Variables init
		self.start = {x=defaultX or 100, y=defaultY or 100} -- position when bullet starts
		self.bullets = {}
		self.speed = speed or 125
		self.sprite = false
		self.spriteFile = nil
		self.r,self.g,self.b = 0, 0, 0

	-- #Simple function for change the color of the bullet
		self.changeColor = function (r,g,b) self.r,self.g,self.b  = r,g,b end

	-- #Simple function for change the current position
		self.changePos = function (x,y) self.start.x, self.start.y = x or self.start.x, y or self.start.y end

	-- #Function to change the sprite of the bullet (image or dot)
		--call without arguments display dots,else display the [arg] image
		self.changeSprite = function (image)
			if type(image)=="nil" then
				self.sprite = false
			else
				self.sprite = love.filesystem.exists(image)
				if self.sprite then self.spriteFile = love.graphics.newImage(image) end
			end
		end

	-- #Function to call in love.draw()
		self.draw = function ()
			for i,v in ipairs(self.bullets) do
				if self.sprite then
					love.graphics.setColor(255,255,255,255);
					love.graphics.draw(self.spriteFile,v.x,v.y,v.angle)
				else
					love.graphics.setColor(self.r, self.g, self.b)
					love.graphics.circle("fill", v.x, v.y, 3)
				end

			end
		end

	-- #Function to call in love.update()
		self.update = function(dt)
			for i,v in ipairs(self.bullets) do
				v.x = v.x + (v.dx * dt)
				v.y = v.y + (v.dy * dt)
			end
		end

	-- #Function for add a bullet,with target.

		self.fire = function (targetX,targetY)
			local startX ,startY = self.start.x, self.start.y --the shoot starts here
			local angle = math.atan2((targetY - startY), (targetX - startX))
			local bulletDx = self.speed * math.cos(angle)
			local bulletDy = self.speed * math.sin(angle)
	 
			table.insert(self.bullets, {x = startX, y = startY, dx = bulletDx, dy = bulletDy,angle = angle})
		end

return self end --ending class